#include <stdio.h>
#include <err.h>
#include <stdint.h>
#include <string.h>

int main(int argc, char **argv) {
	FILE *f;
	uint8_t sum = 0x14;
	int c;
	char *progname = argv[0];

	if(argc > 1 && !strcmp(argv[1], "-e")) {
		sum = 0;
		argc--;
		argv++;
	}

	if(argc != 2) {
		errx(1, "Usage: %s [-e] file.binary", progname);
	}

	f = fopen(argv[1], "r+b");
	if(!f) {
		err(1, "%s", argv[1]);
	}

	while((c = fgetc(f)) != EOF) sum -= c;

	fseek(f, 5, SEEK_SET);
	fwrite(&sum, 1, 1, f);

	fclose(f);

	return 0;
}
