			include "propeller.i"
			include "demo.i"

			org	0
EXITTIME		=	960

			mov	t1, #DITHER_2_6
			wrbyte	t1, =@ditherstyle
			wrlong	frontback, =@backbuf
			add	xzframe, #400
loop
			add	frame, #1

			mov	sin_a, frame
			shl	sin_a, #4
			max	sin_a, =$800
			call	#sin
			shr	addr, #2
			mov	xoffset, =64 << 8
			sub	xoffset, addr

			mov	0, PAR			wz nr
		if_nz	jmp	#:noexit
			mov	sin_a, frame
			sub	sin_a, =EXITTIME	wc
		if_c	jmp	#:noexit
			shl	sin_a, #3
			max	sin_a, =$800
			call	#cos
			shr	addr, #2
			neg	xoffset, =64 << 8
			add	xoffset, addr
:noexit
			mov	sin_a, frame
			shl	sin_a, #5
			call	#sincos
			sar	sin_sin, #6
			sar	sin_cos, #6
			mov	yoffset, sin_sin
			add	xoffset, sin_cos

			mov	0, PAR			wz nr
		if_nz	mov	xoffset, #0
		if_nz	mov	yoffset, #0

			neg	t1, =$a00
			shr	mulu_x, #5
			add	t1, mulu_x
			shr	mulu_x, #2
			add	t1, mulu_x
			add	xzframe, #24
			add	yzframe, #19

			mov	cmd, #RAST_CLEAR
			call	#rastercall

			mov	sin_a, xzframe
			call	#sincos

			mov	worldx + 0, sin_cos
			shl	worldx + 0, #2
			mov	worldx + 2, sin_sin
			shl	worldx + 2, #2

			neg	worldz + 0, sin_sin
			shl	worldz + 0, #2
			mov	worldz + 2, sin_cos
			shl	worldz + 2, #2

			mov	worldx + 1, =$00000000

			mov	worldy + 0, =$00000000
			mov	worldy + 1, =$00040000
			mov	worldy + 2, =$00000000

			mov	worldz + 1, =$00000000

			mov	sin_a, yzframe
			call	#sincos
			sar	sin_sin, #9
			sar	sin_cos, #9

			mov	mulu_x, worldx + 1
			mov	mulu_s, sin_cos
			call	#muls
			mov	accum1, mulu_s
			mov	mulu_x, worldx + 2
			mov	mulu_s, sin_sin
			call	#muls
			add	accum1, mulu_s

			mov	mulu_x, worldx + 1
			mov	mulu_s, sin_sin
			call	#muls
			neg	accum2, mulu_s
			mov	mulu_x, worldx + 2
			mov	mulu_s, sin_cos
			call	#muls
			add	accum2, mulu_s

			mov	worldx + 1, accum1
			mov	worldx + 2, accum2

			mov	mulu_x, worldy + 1
			mov	mulu_s, sin_cos
			call	#muls
			mov	accum1, mulu_s
			mov	mulu_x, worldy + 2
			mov	mulu_s, sin_sin
			call	#muls
			add	accum1, mulu_s

			mov	mulu_x, worldy + 1
			mov	mulu_s, sin_sin
			call	#muls
			neg	accum2, mulu_s
			mov	mulu_x, worldy + 2
			mov	mulu_s, sin_cos
			call	#muls
			add	accum2, mulu_s

			mov	worldy + 1, accum1
			mov	worldy + 2, accum2

			mov	mulu_x, worldz + 1
			mov	mulu_s, sin_cos
			call	#muls
			mov	accum1, mulu_s
			mov	mulu_x, worldz + 2
			mov	mulu_s, sin_sin
			call	#muls
			add	accum1, mulu_s

			mov	mulu_x, worldz + 1
			mov	mulu_s, sin_sin
			call	#muls
			neg	accum2, mulu_s
			mov	mulu_x, worldz + 2
			mov	mulu_s, sin_cos
			call	#muls
			add	accum2, mulu_s

			mov	worldz + 1, accum1
			mov	worldz + 2, accum2

			mov	count, #7
			movd	p_destx, #vertices
			movd	p_desty, #vertices + 1
mkvert
			mov	x, #0
			mov	y, #0
			mov	z, #0

			movs	p_src, #worldx
			test	count, #4	wz
			call	#vaddsub
			test	count, #2	wz
			call	#vaddsub
			test	count, #1	wz
			call	#vaddsub

			call	#project

			sub	count, #1	wc
		if_nc	jmp	#mkvert

			call	#waitraster

			mov	colour, worldx + 2
			call	#shade
		if_c	jmp	#:sk1
			mov	addr, =@rast_x1
			mov	reg, #vertices + %100 * 2
			call	#store
			mov	reg, #vertices + %110 * 2
			call	#store
			mov	reg, #vertices + %111 * 2
			call	#store
			mov	reg, #vertices + %101 * 2
			call	#store

			mov	cmd, #RAST_QUAD
			call	#rastercall

			call	#waitraster
:sk1
			mov	colour, worldy + 2
			call	#shade
		if_c	jmp	#:sk2
			mov	addr, =@rast_x1
			mov	reg, #vertices + %110 * 2
			call	#store
			mov	reg, #vertices + %010 * 2
			call	#store
			mov	reg, #vertices + %011 * 2
			call	#store
			mov	reg, #vertices + %111 * 2
			call	#store

			mov	cmd, #RAST_QUAD
			call	#rastercall

			call	#waitraster
:sk2
			neg	colour, worldx + 2
			call	#shade
		if_c	jmp	#:sk3
			mov	addr, =@rast_x1
			mov	reg, #vertices + %010 * 2
			call	#store
			mov	reg, #vertices + %000 * 2
			call	#store
			mov	reg, #vertices + %001 * 2
			call	#store
			mov	reg, #vertices + %011 * 2
			call	#store

			mov	cmd, #RAST_QUAD
			call	#rastercall

			call	#waitraster
:sk3
			neg	colour, worldy + 2
			call	#shade
		if_c	jmp	#:sk4
			mov	addr, =@rast_x1
			mov	reg, #vertices + %000 * 2
			call	#store
			mov	reg, #vertices + %100 * 2
			call	#store
			mov	reg, #vertices + %101 * 2
			call	#store
			mov	reg, #vertices + %001 * 2
			call	#store

			mov	cmd, #RAST_QUAD
			call	#rastercall

			call	#waitraster
:sk4
			neg	colour, worldz + 2
			call	#shade
		if_c	jmp	#:sk5
			mov	addr, =@rast_x1
			mov	reg, #vertices + %000 * 2
			call	#store
			mov	reg, #vertices + %010 * 2
			call	#store
			mov	reg, #vertices + %110 * 2
			call	#store
			mov	reg, #vertices + %100 * 2
			call	#store

			mov	cmd, #RAST_QUAD
			call	#rastercall

			call	#waitraster
:sk5
			mov	colour, worldz + 2
			call	#shade
		if_c	jmp	#:sk6
			mov	addr, =@rast_x1
			mov	reg, #vertices + %001 * 2
			call	#store
			mov	reg, #vertices + %101 * 2
			call	#store
			mov	reg, #vertices + %111 * 2
			call	#store
			mov	reg, #vertices + %011 * 2
			call	#store

			mov	cmd, #RAST_QUAD
			call	#rastercall

			call	#waitraster
:sk6
			' swap buffers
			rol	frontback, #16
			wrlong	frontback, =@backbuf
			wrbyte	zero, =@internalvbl
:wvbl			rdbyte	t1, =@internalvbl
			tjz	t1, #:wvbl

			jmp	#loop

shade
			sub	colour, =18<<12
			mov	colour, colour		wc
			'mins	colour, #0
			shr	colour, #12
			wrbyte	colour, =@rast_colour
shade_ret		ret

vaddsub
			movd	p_src, #x
			mov	vcount, #3
p_src			sumz	000, 000
			add	p_src, =1<<9 | 1
			djnz	vcount, #p_src
vaddsub_ret		ret

			' Input: x, y, z as 16.16 in [-128.0, 128.0[
			' Output: x, y as 8.8 in [-128.0, 128.0[
project
			sar	z, #14			' fov
			add	z, =$00c0		' zoom
			mov	divu_n, x
			sar	x, #2
			sub	divu_n, x
			mov	divu_d, z
			call	#divs
			add	divu_n, xoffset
p_destx			mov	000, divu_n
			mov	divu_n, y
			mov	divu_d, z
			call	#divs
			add	divu_n, yoffset
p_desty			mov	000, divu_n
			add	p_destx, =2<<9
			add	p_desty, =2<<9
project_ret		ret

store
			movd	:p_1, reg
			add	reg, #1
:p_1			wrword	000, addr
			movd	:p_2, reg
			add	addr, #2
:p_2			wrword	000, addr
			add	addr, #2
store_ret		ret

waitraster
:wait			rdbyte	t1, =@rastercmd
			tjnz	t1, #:wait
waitraster_ret		ret

rastercall
			call	#waitraster
			wrbyte	cmd, =@rastercmd
rastercall_ret		ret

divs
			abs	divu_d, divu_d		wc
			rcl	signed, #1
			abs	divu_n, divu_n		wc
		if_c	xor	signed, #1
			call	#divu
			rcr	signed, #1		wc
			negc	divu_n, divu_n
divs_ret		ret

divu			shl	divu_d, #15
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			cmpsub	divu_n, divu_d		wc
			rcl	divu_n, #1
			and	divu_n, =$ffff
divu_ret		ret

sincos
			call	#sin
			negnz	sin_sin, addr
			call	#cos
			negnz	sin_cos, addr
sincos_ret		ret

			' |sin(sin_a[12..0])| -> sin_a[15..0], (sin(sin_a[12..0]) >= 0) -> z

cos			add	sin_a, =$0800
sin			mov	addr, sin_a
			test	addr, =$0800		wc
			test	addr, =$1000		wz
			and	addr, =$07ff
		if_c	xor	addr, =$07ff
			shl	addr, #1
			or	addr, =$e000
			rdword	addr, addr
cos_ret
sin_ret			ret

muls
			sar	mulu_x, #8
			abs	mulu_x, mulu_x		wc
			rcl	signed, #1
			abs	mulu_s, mulu_s		wc
		if_c	xor	signed, #1
			call	#mulu
			rcr	signed, #1		wc
			negc	mulu_s, mulu_s
			shl	mulu_s, #1
muls_ret		ret

			' mulu_x[15..0] * mulu_s[7..0] -> mulu_s[23..0] (clobbers c, preserves z)
			' 4*21 cycles
mulu
			shl	mulu_x, #16
			shr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
		if_c	add	mulu_s, mulu_x		wc
			rcr	mulu_s, #1		wc
			shr	mulu_s, #8
mulu_ret		ret

frontback		word	@graphics0, @graphics1

			pool

frame			long	50

xzframe			long	0
yzframe			long	0

x			res	1
y			res	1
z			res	1

worldx			res	3
worldy			res	3
worldz			res	3

cmd			res	1
t1			res	1
reg			res	1
addr			res	1
count			res	1
vcount			res	1

vertices		res	16

divu_n			res	1
divu_d			res	1
signed			res	1

sin_a			res	1
sin_sin			res	1
sin_cos			res	1

accum1			res	1
accum2			res	1

mulu_x			res	1
mulu_s			res	1

xoffset			res	1
yoffset			res	1

colour			res	1

			vfit	496
